package es.uca.takuan.client;

/** Event listener
 * This interface must be implemented by the class that will be
 * called with the events generated by Remote
 * @author Alejandro Álvarez Ayllón
 * @see Remote
 */
public abstract class EventListener {

    // Attributes
    private Remote remote;

    /** Set the remote instance
     * @param r
     */
    public void setRemote(Remote r) {
        remote = r;
    }

    /** Get the remote instance we are listening
     * @return
     */
    public Remote getRemote() {
        return remote;
    }

    // Abstract methods

    /** This is called when a file has been successfully sended
     * @param fName The name of the file
     */
    public abstract void fileSended(String fName);

    /** This is called when the state changes
     * @param state The new state
     * @see es.uca.takuan.client.Remote
     */
    public abstract void stateChanged(int state);

    /** This is called to update the state of a file being sended
     * @param size      The total size of the file
     * @param sended    The sended bytes
     */
    public abstract void fileSending(long size, long sended);

    /** This is called with output messages
     * @param str   The message
     */
    public abstract void trace(String str);
}
